package ij.util;

import ij.IJ;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.FontMetrics;

import javax.swing.UIManager;

/**
This class contains static methods that use the Java 2 API. They are isolated
here to prevent errors when ImageJ is running on Java 1.1 JVMs.
*/
public class Java2 {

	//private static boolean lookAndFeelSet;

	public static void setAntialiased(Graphics g, boolean antialiased) {
			Graphics2D g2d = (Graphics2D)g;
			if (antialiased)
				g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
			else
				g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_OFF);
	}

        public static void setAntialiased(Graphics2D g2d, boolean antialiased) {
                        //Graphics2D g2d = (Graphics2D)g;
                        if (antialiased)
                                g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
                        else
                                g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_OFF);
        }

	public static void setAntialiasedText(Graphics g, boolean antialiasedText) {
			Graphics2D g2d = (Graphics2D)g;
			if (antialiasedText)
				g2d.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
			else
				g2d.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_OFF);
	}

	public static int getStringWidth(String s, FontMetrics fontMetrics, Graphics g) {
			java.awt.geom.Rectangle2D r = fontMetrics.getStringBounds(s, g);
			return (int)r.getWidth();
	}

	public static void setBilinearInterpolation(Graphics g, boolean bilinearInterpolation) {
			Graphics2D g2d = (Graphics2D)g;
			if (bilinearInterpolation)
				g2d.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BILINEAR);
			else
				g2d.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_NEAREST_NEIGHBOR);
	}

	/** Sets the Swing look and feel to the system look and feel (Windows only).
	public static void setSystemLookAndFeel() {
		if (lookAndFeelSet || !IJ.isWindows()) return;
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch(Throwable t) {}
		lookAndFeelSet = true;
		IJ.register(Java2.class);
	}*/



            private static boolean lookAndFeelSet;
            protected static String metal= "Metal";
            public static int METAL= 0;
            //protected static String metalClassName = "javax.swing.plaf.metal.MetalLookAndFeel";
            protected static String metalClassName = "org.jdesktop.swingx.plaf.metal.MetalLookAndFeelAddons";

            protected static String motif = "SunOS";
            public static int MOTIF= 1;
            protected static String motifClassName = "com.sun.java.swing.plaf.motif.MotifLookAndFeel";

            protected static String windows = "Windows";
            public static int WINDOWS= 2;
            protected static String windowsClassName = "com.sun.java.swing.plaf.windows.WindowsLookAndFeel";
            //protected static String windowsClassName = "org.jdesktop.swingx.plaf.windows.WindowsClassicLookAndFeelAddons";

            protected static String mac = "Mac";
            public static int MAC= 3;
            protected static String macClassName = "ch.randelshofer.quaqua.QuaquaLookAndFeel";

            protected static String gtk = "GTK";
            public static int GTK= 4;
            private static final String gtkClassName  = "com.sun.java.swing.plaf.gtk.GTKLookAndFeel";

            protected static String macosx = "MacOSX";
            public static int MACOSX= 6;
            //private static final String macosxClassName  = "org.jdesktop.swingx.plaf.macosx.MacOSXLookAndFeelAddons";
            private static final String macosxClassName  = "ch.randelshofer.quaqua.QuaquaLookAndFeel";

            protected static String linux= "Linux";
            public static int LINUX= 5;
            //protected static String metalClassName = "javax.swing.plaf.metal.MetalLookAndFeel";
            protected static String linuxClassName = "org.jdesktop.swingx.plaf.linux.LinuxLookAndFeelAddons";


            /** Sets the Swing look and feel to the system look and feel. */
            public static void setSystemLookAndFeel() {
                    if (lookAndFeelSet) return;
                    try {
                            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
                    } catch(Throwable t) {}
                    lookAndFeelSet = true;
                    IJ.register(Java2.class);
            }

            /** Sets the Swing look and feel to the system look and feel. */
            public static void setSystemLookAndFeel(int SystemCode) {
                if (lookAndFeelSet)
                        return;
                String systemName = metalClassName;
                switch (SystemCode) {
                case 0:
                    systemName = metalClassName;
                    break;
                case 1:
                    systemName = motifClassName;
                    break;
                case 2:
                    systemName = windowsClassName;
                    break;
                case 3:
                    systemName = macClassName;
                    break;
                case 4:
                    systemName = gtkClassName;
                    break;
                case 5:
                    systemName = linuxClassName;
                    break;
                case 6:
                    systemName = macosxClassName;
                    break;
                }
                try {
                    UIManager.setLookAndFeel(systemName);
                } catch (Exception ex) {
                }
                lookAndFeelSet = true;
                IJ.register(Java2.class);
                }

}

