package ij2x.plugin;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Insets;

import java.net.URL;

import java.util.StringTokenizer;
import java.util.Vector;

import java.text.DateFormat;

import java.util.Date;
import java.util.MissingResourceException;
import java.util.Locale;
import java.util.ResourceBundle;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.BevelBorder;
import javax.swing.BorderFactory;
import javax.swing.border.Border;

import ij.IJ;
import ij.ImageJ;
import ij.ImagePlus;
import ij.Prefs;
import ij.WindowManager;
import ij.plugin.PlugIn;
import ij.plugin.OverlayCommands;

import ij2x.util.AWTImages;
import ij2x.util.ImageIcons;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2012</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class ControlBarPanel extends JPanel implements PlugIn, ActionListener, MouseListener, MouseMotionListener, Runnable{

    protected ImagePlus imp;
    protected ImageJ ij;
    private int offset=60, offsetHeight;
    public JButton infoButton, draggedButton, closeButton, undecoratedButton, action;
    protected JButton newButton, openButton, undoButton, copyButton, cutButton, pasteButton
            , clearButton, fillButton, drawButton
            , roicolorButton, colorpickerButton
            , selectButton, nonselectButton
            , splineButton, duplicateButton, captureButton, rotateButton, clockButton, specifyButton;
    private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
    private Border lightGrayBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.lightGray, Color.lightGray);
    private long mouseDownTime;
    private static int current;
    public static final int DOUBLE_CLICK_THRESHOLD = 150;
    public JPanel controlBarPanel=new JPanel();
    public JLabel spaceLabel, clockLabel, label;
    public JPanel panel=new JPanel();
    protected Date date = new Date();

    private boolean running=false;
    private Thread timer;
    private String time;
    private DateFormat timeFormat;
    private static boolean isparent = false;
    private static ResourceBundle resources;
    private static String fileType = ".gif";
    private static String dir;
    private int index = 0;
    private static int ARRAYLENGTH = 20;
    private static int PARTSLENGTH = 3;

    static {
        try {
            resources = ResourceBundle.getBundle("ij2x.plugin.resources.ControlBar",
                                                 Locale.getDefault());
        } catch (MissingResourceException mre) {
            System.err.println("resources/ControlBar.properties not found");
            System.exit(1);
        }
    }


    public ControlBarPanel() {
        ij = IJ.getInstance();
        timeFormat= DateFormat.getTimeInstance(DateFormat.DEFAULT);
        start();
}

     public void run(String arg){
        ij = IJ.getInstance();
        controlBarPanel=createControlBar();
   }

     protected String getResourceString(String nm) {
        String str;
        try {
            str = resources.getString(nm);
        } catch (MissingResourceException mre) {
            str = null;
        }
        return str;
    }

      protected URL getResource(String key) {
         String name = getResourceString(key);
         if (name != null) {
             URL url = this.getClass().getResource(name);
             return url;
         }
         return null;
     }

     /**
      * Take the given string and chop it up into a series
      * of strings on whitespace boundaries.  This is useful
      * for trying to get an array of strings out of the
      * resource file.
      */
      protected String[] tokenize(String input) {
         Vector<String> v = new Vector<String>();
         StringTokenizer t = new StringTokenizer(input);
         String cmd[];

         while (t.hasMoreTokens())
             v.addElement(t.nextToken());
         cmd = new String[v.size()];
         for (int i = 0; i < cmd.length; i++)
             cmd[i] = v.elementAt(i);

         return cmd;
     }


    public JPanel createControlBar(){

        java.awt.FlowLayout flayout = new java.awt.FlowLayout(java.awt.FlowLayout.LEFT);
        flayout.setHgap(0);
        flayout.setVgap(0);
        panel.setLayout(flayout);
        panel.setBorder(lightGrayBorder);
        clockLabel=createLabel(clockLabel, "", "00:00:00");
        this.setDate(new Date());
        clockLabel.setBorder(lightGrayBorder);
        dir = Prefs.getString("icondir");

        //toolbar= image open undo copy cut paste clear fill draw duplicate selectall deselect fitspline threecolor jcolopicker cupture info  rotate scale spezifyroi
        //          0      1    2    3   4    5     6     7    8      9        10        11       12        13          14          15    16    17     18     19


    ImageIcon b1o = ImageIcons.getIcons(this);

    AWTImages.setImageDir("controlDir");

    String[] iconAllName = tokenize(getResourceString("controlbar"));
    Image[][] icons = new Image[iconAllName.length][3];
    for(int i=0; i < iconAllName.length; i++){
        for(int j=0; j < 3; j++){
            icons[i][j]=((ImageIcon)AWTImages.createBufferedIcon(
                    this
                      , tokenize(getResourceString(iconAllName[i]))[j]
                        , b1o.getImage()
                          , 24)).getImage();
        }
    }

    newButton=createButton(newButton, "New Image", icons[index++]);

    openButton=createButton(openButton, "Open Image", icons[index++]);

    undoButton=createButton(undoButton, "Undo Action", icons[index++]);

    copyButton=createButton(copyButton, "Copy Shape", icons[index++]);

    cutButton=createButton(cutButton, "Cut Shape", icons[index++]);

    pasteButton=createButton(pasteButton, "Paste Shape", icons[index++]);

    clearButton=createButton(clearButton, "Clear Shape", icons[index++]);

    fillButton=createButton(fillButton, "Fill Pixel", icons[index++]);

    drawButton=createButton(drawButton, "Draw Pixel", icons[index++]);

    roicolorButton=createButton(roicolorButton, "Shape Color", icons[index++]);

    colorpickerButton=createButton(colorpickerButton, "JColor Picker", icons[index++]);

    specifyButton=createButton(specifyButton, "Spezify Roi", icons[index++]);

    selectButton=createButton(selectButton, "Select Image", icons[index++]);

    nonselectButton=createButton(nonselectButton, "Non Select Image", icons[index++]);

    splineButton=createButton(splineButton, "Fit Spline", icons[index++]);

    duplicateButton=createButton(duplicateButton, "Duplicate Image", icons[index++]);

    captureButton=createButton(captureButton, "Capture Screen", icons[index++]);

    infoButton=createButton(infoButton, "Show Info ...", icons[index++]);

    clockButton = createButton(clockButton, "Clock Button", icons[index]);


        spaceLabel = new JLabel("", JLabel.CENTER);
        offsetHeight=(int)infoButton.getPreferredSize().getHeight();
        spaceLabel.setMinimumSize(new Dimension(offset, offsetHeight));
        spaceLabel.setMaximumSize(new Dimension(offset, offsetHeight));
        spaceLabel.setPreferredSize(new Dimension(offset, offsetHeight));
        spaceLabel.setBorder(lightGrayBorder);
        panel.add(newButton);
        panel.add(openButton);
        panel.add(undoButton);
        panel.add(copyButton);
        panel.add(cutButton);
        panel.add(pasteButton);
        panel.add(clearButton);
        panel.add(fillButton);
        panel.add(drawButton);
        //panel.add(roicolorButton);
        panel.add(colorpickerButton);
        panel.add(specifyButton);
        panel.add(selectButton);
        panel.add(nonselectButton);
        panel.add(splineButton);
        panel.add(duplicateButton);
        panel.add(captureButton);
        panel.add(infoButton);
        panel.add(clockButton);

        JPanel stbPanel = new JPanel();
        stbPanel.setLayout(new BorderLayout());
        stbPanel.add(BorderLayout.WEST, panel);
        return stbPanel;
     }
     private JLabel createLabel(JLabel label, String tooltip, String text){
         label = new JLabel(text);
         label.setToolTipText(tooltip);
         label.addMouseListener(new MouseListener(){
         public void mousePressed(MouseEvent e){
             if (!e.isMetaDown()){
                 labelEvent(e);
             }
         }
         public void mouseReleased(MouseEvent e) {}
         public void mouseExited(MouseEvent e) {}
         public void mouseClicked(MouseEvent e) {}
         public void mouseEntered(MouseEvent e) {}
         });
     return label;
     }

     public void labelEvent(MouseEvent e){
         JLabel label = (JLabel)e.getSource();
         JFrame[] editFrame = WindowManager.getNonImageWindows();
         if(editFrame.length > 1){
             for (int i = 0; i < editFrame.length; i++) {
                 //IJ.log("" + editFrame[i].getClass().getName());
                 if (editFrame[i].getClass().getName().equals(
                         "com.ibm.JCalendar")) {
                     isparent = true;
                     editFrame[i].setVisible(false);
                     WindowManager.removeWindow(editFrame[i]);
                 } else
                     isparent = false;
             }
         }else
         if (editFrame.length == 1 && editFrame[0].getClass().getName().equals(
                 "com.ibm.JCalendar")) {
             isparent = true;
             editFrame[0].setVisible(false);
             WindowManager.removeWindow(editFrame[0]);
         }else isparent = false;
        if(label==clockLabel && !isparent){
           IJ.runPlugIn("com.ibm.JCalendar", "");
       }
     }
     private JButton createButton(JButton action, String tooltip, Image[] image){
          action = new JButton();
            action.setToolTipText(tooltip);
             action.addActionListener(this);
                 action.addMouseListener(this);
             action.addMouseMotionListener(this);
            setBorderlessButton(action);
           if(image != null)
              setIcon(action, image);
     return action;
     }


     private void setIcon(JButton action, Image[] image){
           action.setIcon(new ImageIcon(image[0]));
             action.setRolloverIcon(new ImageIcon(image[1]));
           action.setPressedIcon(new ImageIcon(image[2]));
     }

     void setButtonDim(JButton action, Dimension maxDim, Dimension preDim, Dimension minDim){
           action.setMaximumSize(maxDim);
           action.setPreferredSize(preDim);
           action.setMinimumSize(minDim);
   }

     void setBorderlessButton(JButton button){
           button.setMargin(new Insets(0, 0, 0, 0));
           button.setBorderPainted(false);
           button.setContentAreaFilled(false);
           button.setFocusPainted(false);
       }

       public void mousePressed(MouseEvent e) {
           action = (JButton)e.getSource();
           int x = e.getX();
           boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
           mouseDownTime = System.currentTimeMillis();
                if (!doubleClick) {
                }
        }

        public void mouseReleased(MouseEvent e) {}
        public void mouseExited(MouseEvent e) {}
        public void mouseClicked(MouseEvent e) {}
        public void mouseEntered(MouseEvent e) {}

        public void mouseDragged(MouseEvent e) {}
        public void mouseMoved(MouseEvent e) {
            JButton action = (JButton)e.getSource();
            int x = e.getX();
            boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
            mouseDownTime = System.currentTimeMillis();
                 if (!false) {
                     if(action == infoButton){
                         IJ.showStatus("Command: Show Info...");
                     }
                     else if(action == openButton){
                         IJ.showStatus("Command: Open...");
                     }
                     else if(action == newButton){
                         IJ.showStatus("Command: Image...");
                     }
                     else if(action == undoButton){
                         IJ.showStatus("Command: Undo");
                     }
                     else if(action == copyButton){
                         IJ.showStatus("Command: Copy");
                     }
                     else if(action == cutButton){
                         IJ.showStatus("Command: Cut");
                     }
                     else if(action == pasteButton){
                         IJ.showStatus("Command: Paste");
                     }
                     else if(action == clearButton){
                         IJ.showStatus("Command: Clear");
                     }
                     else if(action == fillButton){
                         IJ.showStatus("Command: Fill");
                     }
                     else if(action == drawButton){
                         IJ.showStatus("Command: Draw");
                     }
                     else if(action == duplicateButton){
                         IJ.showStatus("Command: Duplicate...");
                     }
                     /*else if(action == scaleButton){
                         IJ.showStatus("Command: Scale...");
                     }*/
                     else if(action == selectButton){
                         IJ.showStatus("Command: Select All");
                     }
                     else if(action == nonselectButton){
                         IJ.showStatus("Select None");
                     }
                     /*else if(action == rotateButton){
                         IJ.showStatus("Command: Arbitrarily...");
                     }*/
                     else if(action == splineButton){
                         IJ.showStatus("Command: Fit Spline");
                     }
                     else if(action == roicolorButton){
                             IJ.showStatus("Command: Roi Color");
                     }
                     else if(action == colorpickerButton){
                         IJ.showStatus("Command: JColor Picker...");
                     }
                     else if(action == captureButton){
                         IJ.showStatus("Command: Capture Screen ");
                     }
                     /*else if (action == draggedButton) {
                         IJ.showStatus("Move...");
                     }
                     else if (action == closeButton) {
                         IJ.showStatus("Decorated Frame");
                     }
                     else if (action == undecoratedButton) {
                         IJ.showStatus("Undecorated Frame");
                     }*/

                 }
        }
        // Action listener method
        public void actionPerformed(ActionEvent e){
            try {
                if(action == infoButton){
                    IJ.doCommand("Show Info...");
                }
                else if(action == openButton){
                    IJ.doCommand("Open...");
                }
                else if(action == newButton){
                    IJ.doCommand("Image...");
                    //IJ.run("Image...", "");
                }
                else if(action == undoButton){
                    IJ.doCommand("Undo");
                }
                else if(action == copyButton){
                    IJ.doCommand("Copy");
                }
                else if(action == cutButton){
                    IJ.doCommand("Cut");
                }
                else if(action == pasteButton){
                    IJ.doCommand("Paste");
                }
                else if(action == clearButton){
                    IJ.doCommand("Clear");
                }
                else if(action == fillButton){
                    IJ.doCommand("Fill");
                }
                else if(action == drawButton){
                    IJ.doCommand("Draw");
                }
                /*else if(action == drawOverlayButton){
                    //OverlayCommands.addSelection();
                    IJ.doCommand("Add Selection...");
                }
                else if(action == removeOverlayButton){
                    //OverlayCommands.remove();
                    IJ.doCommand("Remove Overlay");
                }*/
                else if(action == duplicateButton){
                    IJ.doCommand("Duplicate...");
                }
                else if(action == selectButton){
                    IJ.doCommand("Select All");
                }
                else if(action == nonselectButton){
                    IJ.doCommand("Select None");
                }
                else if(action == splineButton){
                    IJ.doCommand("Fit Spline");
                }
                else if(action == colorpickerButton){
                    if(!IJ.isWindows()){
                        IJ.runPlugIn("ij2x.plugin.frame.ColorPane", "");
                    }else{
                        IJ.runPlugIn("ij2x.plugin.frame.ColorPane", "");
                    }
                }
                else if(action == roicolorButton){
                        IJ.runPlugIn("ij2x.plugin.ThreeColor","");
                }
                else if(action == captureButton){
                    IJ.doCommand("Capture Screen");
                }
                else if(action == specifyButton){
                    IJ.doCommand("Specify...");
                }
                else if(action == clockButton){
                    JFrame[] editFrame = WindowManager.getNonImageWindows();
                    if(editFrame.length > 1){
                        for (int i = 0; i < editFrame.length; i++) {
                            //IJ.log("" + editFrame[i].getClass().getName());
                            if (editFrame[i].getClass().getName().equals(
                                    "ij2x.plugin.frame.JCalendar")) {
                                isparent = true;
                                editFrame[i].setVisible(false);
                                WindowManager.removeWindow(editFrame[i]);
                            } else
                                isparent = false;
                        }
                    }else
                    if (editFrame.length == 1 && editFrame[0].getClass().getName().equals(
                            "ij2x.plugin.frame.JCalendar")) {
                        isparent = true;
                        editFrame[0].setVisible(false);
                        WindowManager.removeWindow(editFrame[0]);
                    }else isparent = false;
                   if(!isparent){
                      IJ.runPlugIn("ij2x.plugin.frame.JCalendar", "");
                  }
                }
            } catch (Exception ex) {

            }
        }

        public static final String cutAction = "cut";
        public static final String copyAction = "copy";
        public static final String openAction = "open";
        private Action[] defaultActions = {
                                          new CopyAction(),
                                          new CutAction(),
                                          new OpenAction()
        };

        class OpenAction extends AbstractAction {

            OpenAction() {
                super(openAction);
            }

            public void actionPerformed(ActionEvent e) {
                IJ.doCommand("Open...");
            }
        }

        class CopyAction extends AbstractAction {

            CopyAction() {
                super(copyAction);
            }

            public void actionPerformed(ActionEvent e) {
                IJ.doCommand("Copy");
            }
        }

        class CutAction extends AbstractAction {

            CutAction() {
                super(cutAction);
            }

            public void actionPerformed(ActionEvent e) {
                IJ.doCommand("Cut");
            }
        }


        public void setDate(Date date) {
            this.date = date;
        }

        /* geter methods for the timeFormat value*/
        public String getTimeFormatToString() {
            return time;
        }

        /* seter methods for the timeFormat value*/
        public void setTimeFormatToString(String time) {
            this.time = time;
        }

        /* interface Runnable methods */
        public void start() {
            running = true;
            if (timer == null)
                timer = new Thread(this);
            timer.start();
        }

        public void stop() {
            timer = null;
            notify();
        }

        public void run() {
            while (running) {
                String tFormat = timeFormat.format(new Date());
                setTimeFormatToString(tFormat);
                this.setDate(new Date());
                try {
                    Thread.sleep(100);
                    if(clockLabel != null){
                        clockLabel.setText(tFormat);
                        clockLabel.setToolTipText("Die Zeit:" + tFormat);
                        if(clockButton != null)
                        clockButton.setToolTipText("Die Zeit:" + tFormat);
                    }
                 } catch (Exception e) {
                    e.printStackTrace();
                }
            }
            timer = null;
        }

}
