package ij2x.plugin;

import ij.*;
import ij.gui.*;
import ij.process.*;
import ij.util.Tools;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.JFormattedTextField;
import javax.swing.JSpinner;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import javax.swing.BorderFactory;
import ij.plugin.PlugIn;
import javax.swing.JPanel;

/** This plugin implements the Edit/Scale command. */
//public class Scaler implements PlugInFilter, DocumentListener {

/** This plugin implements the Edit/Scale command. */
public class Translator implements PlugIn, DocumentListener, FocusListener {
    private ImagePlus imp;
    private static String xstr = "0.5";
    private static String ystr = "0.5";
    private static int newWidth, newHeight;
    private static boolean newWindow = true;
    //private static boolean interpolate = true;
    private static boolean fillWithBackground;
    private static boolean processStack = true, processMove = true;
    private static double xtrans=0.0;
    private static double ytrans=0.0;
    private String title = "Untitled";
    private Vector<JComponent> fields;
    private double bgValue;
    private boolean constainAspectRatio = true;
    private JTextField widthField, heightField;
    private Document[] doc= new Document[4];
    private Rectangle r;
    private Object fieldWithFocus;
    private JFormattedTextField xtextField, ytextField;
    private JSpinner xspinner, yspinner;
    private Vector<JComponent> spinnerFields=new Vector<JComponent>(), spinners=new Vector<JComponent>();
    private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
    private Border grayBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.gray, Color.lightGray);

        public void run(String arg) {
                imp = IJ.getImage();
                Roi roi = imp.getRoi();
                if (roi!=null && !roi.isArea())
                        imp.killRoi(); // ignore any line selection
                ImageProcessor ip = imp.getProcessor();
                if (!showDialog(ip))
                        return;
                ip.setBackgroundValue(bgValue);
                imp.startTiming();
                try {
                    //if (newWindow && imp.getStackSize()>1 && processStack)
                        if (imp.getStackSize()>1 && processStack)
                                createNewStack(imp, ip);
                        else
                                translate(ip);
                }
                catch(OutOfMemoryError o) {
                        IJ.outOfMemory("Translate");
                }
                IJ.showProgress(1.0);
        }

        void createNewStack(ImagePlus imp, ImageProcessor ip) {
                Rectangle r = ip.getRoi();
                boolean crop = r.width!=imp.getWidth() || r.height!=imp.getHeight();
                int nSlices = imp.getStackSize();
            ImageStack stack1 = imp.getStack();
            ImageStack stack2 = new ImageStack(newWidth, newHeight);
                ImageProcessor ip1, ip2;
                double wscale=0, hscale=0;
                for (int i=1; i<=nSlices; i++) {
                        IJ.showStatus("Translate: " + i + "/" + nSlices);
                        ip1 = stack1.getProcessor(i);
                        String label = stack1.getSliceLabel(i);
                        if (crop) {
                                ip1.setRoi(r);
                                ip1 = ip1.crop();
                        }
                        ip2 = ip1.resize(newWidth, newHeight);
                        if (ip2!=null){
                            if(!processMove){
                                wscale=xtrans;
                                hscale=ytrans;
                            }
                            ip2.setColor((int)bgValue);
                            ip2.fill();
                            ip2.insert(ip1, (int)wscale, (int)hscale);
                            if(processMove){
                                if(Math.abs(wscale) < r.width)wscale+=xtrans;
                                if(Math.abs(hscale) < r.height)hscale+=ytrans;}
                            stack2.addSlice(label, ip2);
                        }
                        IJ.showProgress(i, nSlices);
                }
                if(newWindow){
                    ImagePlus imp2 = imp.createImagePlus();
                    imp2.setStack(title, stack2);
                    //insert(imp, imp2, (int) xscale, (int) yscale);
                    IJ.showProgress(1.0);
                    imp2.show();
                    imp2.changes = true;
                }
                else{
                    //insert(imp, imp2, (int)xscale, (int)yscale);
                    IJ.showProgress(1.0);
                    imp.setStack(title, stack2);
                    imp.updateAndDraw();
                    //String title = imp.getWindow().getTitle();
                    //imp.getWindow().setVisible(false);
                    //imp2.show();
                    //imp2.getWindow().setTitle(title);
                    //imp2.changes = true;
                }
        }

        void translate(ImageProcessor ip) {
                if (newWindow) {
                        Rectangle r = ip.getRoi();
                        ImagePlus imp2 = imp.createImagePlus();
                        imp2.setProcessor(title, ip.resize(newWidth, newHeight));
                        insert(imp, imp2, (int)xtrans, (int)ytrans);
                        imp2.show();
                        imp.trimProcessor();
                        imp2.trimProcessor();
                        imp2.changes = true;
                } else {
                    Rectangle r = ip.getRoi();
                    ImagePlus imp2 = imp.createImagePlus();
                    imp2.setProcessor(title, ip.resize(newWidth, newHeight));
                    insert(imp, imp2, (int)xtrans, (int)ytrans);
                    String title = imp.getWindow().getTitle();
                    imp.trimProcessor();
                    imp.getWindow().setVisible(false);
                    imp2.show();
                    imp2.getWindow().setTitle(title);
                    imp2.trimProcessor();
                    imp2.changes = true;
                }
        }
        void insert(ImagePlus imp1, ImagePlus imp2, int x, int y) {
                ImageStack stack1 = imp1.getStack();
                ImageStack stack2 = imp2.getStack();
                int size1 = stack1.getSize();
                int size2 = stack2.getSize();
                ImageProcessor ip1, ip2;
                for (int i=1; i<=size2; i++) {
                        ip1 = stack1.getProcessor(i<=size1?i:size1);
                        ip2 = stack2.getProcessor(i);
                        ip2.setColor((int)bgValue);
                        ip2.fill();
                        ip2.insert(ip1, x, y);
                        stack2.setPixels(ip2.getPixels(), i);
                }
        }

        boolean showDialog(ImageProcessor ip) {

            GenericDialog gd = new GenericDialog("Translate");
                int bitDepth = imp.getBitDepth();
                boolean isStack = imp.getStackSize()>1;
                r = ip.getRoi();
                int width = newWidth;
                        if (width==0) width = r.width;
                int height = (int)((double)width*r.height/r.width);
                if (xtrans!=0.0 && ytrans!=0.0) {
                        width = (int)(r.width);
                        height = (int)(r.height);
                } else {
                        xstr = "-";
                        ystr = "-";
                }
                String angleXLabel="X  Trans(0-width):";
                String angleYLabel="Y Trans(0-height):";
                double minx=-width;//(width>height?-width/2:-height/2);
                double maxx=width;//(width>height?width/2:height/2);
                double miny=-height;//(width>height?-height/2:-width/2);
                double maxy=height;//(width>height?height/2:width/2);
                int swidth=80, sheight=21;
                JLabel transformLabel = new JLabel(" Translate ");
                transformLabel.setBorder(grayBorder);
                JPanel transformPanel = new JPanel();
                transformPanel.add(transformLabel);
                gd.addPanel(transformPanel, GridBagConstraints.WEST, new Insets(0, 0, 0, 10));
                gd.addSpinner(angleXLabel, minx, maxx, xtrans, swidth, sheight, 1.0);
                gd.addSpinner(angleYLabel, miny, maxy, ytrans, swidth, sheight, 1.0);
                spinnerFields = gd.getSpinnerFields();
                spinners = gd.getSpinners();
                xspinner = (JSpinner)spinners.elementAt(0);
                yspinner = (JSpinner)spinners.elementAt(1);
                gd.setInsets(5, 0, 5);
                gd.addStringField("Width (pixels): ", ""+width);
                gd.addStringField("Height (pixels): ", ""+height);
                fields = gd.getStringFields();
                for (int i=0; i<fields.size(); i++) {
                        ((JTextField)fields.elementAt(i)).getDocument().addDocumentListener(this);
                        doc[i+2]=((JTextField)fields.elementAt(i)).getDocument();
                        ((JTextField)fields.elementAt(i)).addFocusListener(this);
                }
                widthField = (JTextField)fields.elementAt(0);
                heightField = (JTextField)fields.elementAt(1);
                fieldWithFocus = xtextField;
                if (bitDepth==8 || bitDepth==24)
                        gd.addCheckbox("Fill with Background Color", fillWithBackground);
                if (isStack){
                    gd.addCheckbox("Process Entire Stack", processStack);
                    gd.addCheckbox("Process Move Slice", processMove);
                }
                gd.addCheckbox("Create New Window", newWindow);
                title = WindowManager.getUniqueName(imp.getTitle());
                gd.setInsets(10, 0, 0);
                gd.addStringField("Title:", title, 12);
                gd.showDialog();
                if (gd.wasCanceled())
                        return false;
                    Double dx = (Double)xspinner.getValue();
                    Double dy = (Double)yspinner.getValue();
                xtrans = dx.doubleValue();// gd.getNextNumbers();
                ytrans = dy.doubleValue();//  gd.getNextNumbers();
                String wstr = gd.getNextString();
                newWidth = (int)Tools.parseDouble(wstr, 0);
                String hstr = gd.getNextString();
                newHeight = (int)Tools.parseDouble(hstr, 0);
                if (newHeight!=0 && (wstr.equals("-") || wstr.equals("0")))
                newWidth= (int)(newHeight*(double)r.width/r.height);
                if (newWidth==0 || newHeight==0) {
                        IJ.error("Invalid width or height entered");
                        return false;
                }
                if (xtrans>r.width) xtrans = r.width;
                if (ytrans>r.height) ytrans = r.height;
                if (bitDepth==8 || bitDepth==24)
                        fillWithBackground = gd.getNextBoolean();
                if (isStack){
                    processStack = gd.getNextBoolean();
                    processMove = gd.getNextBoolean();
                }
                newWindow = gd.getNextBoolean();
                title = gd.getNextString();

                if (fillWithBackground) {
                        Color bgc = Toolbar.getBackgroundColor();
                        if (bitDepth==8)
                                bgValue = ip.getBestIndex(bgc);
                        else if (bitDepth==24)
                                bgValue = bgc.getRGB();
                } else {
                        if (bitDepth==8)
                                bgValue = ip.isInvertedLut()?0.0:255.0; // white
                        else if (bitDepth==24)
                                bgValue = 0xffffffff; // white
                }
                return true;
        }

      public void textFieldUpdate(DocumentEvent e) {
          Document document = (Document)e.getDocument();
          double newXScale = xtrans;
          double newYScale = ytrans;
          Object source=null;
        for(int i=0; i< doc.length; i++)
            if(document.equals(doc[i])){
                switch (i) {
                case 0:
                    source = xtextField;
                    break;
                case 1:
                    source = ytextField;
                    break;
                case 2:
                    source = widthField;
                    break;
                case 3:
                    source = heightField;
                    break;
                }
            }
        if (source==xtextField && fieldWithFocus==xtextField) {
            String newXText = xtextField.getText();
            newXScale = Tools.parseDouble(newXText,0.0);
            if (newXScale!=xtrans) {
                int newWidth = (int)(r.width);
                widthField.setText(""+newWidth);
                if (constainAspectRatio) {
                }
            }
        } else if (source==ytextField && fieldWithFocus==ytextField) {
            String newYText = ytextField.getText();
            newYScale = Tools.parseDouble(newYText,0.0);
            if (newYScale!=ytrans) {
                int newHeight = (int)(r.height);
                heightField.setText(""+newHeight);
            }
        }
                xtrans = newXScale;
                ytrans = newYScale;
        }

        public void insertUpdate(DocumentEvent e){
            textFieldUpdate(e);
        }
        public void removeUpdate(DocumentEvent e){
            textFieldUpdate(e);
        }
        public void changedUpdate(DocumentEvent e){
        }
        public void focusGained(FocusEvent e) {
        }

        public void focusLost(FocusEvent e) {
            constainAspectRatio = true;
        }

}
